#include "tft_master_1.h"
#include "tft_gfx.h"

#include "symbol_library.h"

#define	WHOLE 0
#define	HALF 1
#define	QUARTER 2
#define	EIGHTH 3

char buffer[60]; 

void drawstaff(short loc)
{
    tft_drawLine  (10, loc,    413, loc,    HX8357_BLACK);//31
    tft_drawLine  (10, loc+1,  413, loc+1,  HX8357_BLACK);//32
    tft_drawLine  (10, loc+9,  413, loc+9,  HX8357_BLACK);//40
    tft_drawLine  (10, loc+10, 413, loc+10, HX8357_BLACK);//41
    tft_drawLine  (10, loc+18, 413, loc+18, HX8357_BLACK);//49
    tft_drawLine  (10, loc+19, 413, loc+19, HX8357_BLACK);//50
    tft_drawLine  (10, loc+27, 413, loc+27, HX8357_BLACK);//58
    tft_drawLine  (10, loc+28, 413, loc+28, HX8357_BLACK);//59
    tft_drawLine  (10, loc+36, 413, loc+36, HX8357_BLACK);//67
    tft_drawLine  (10, loc+37, 413, loc+37, HX8357_BLACK);//68
    tft_drawBitmap(10, loc-18, clef, 32, 72,HX8357_BLACK);
}

void drawbar(short loc)
{
    tft_drawLine(9,   loc, 9,   loc+37, HX8357_BLACK);
    tft_drawLine(10,  loc, 10,  loc+37, HX8357_BLACK);  
    tft_drawLine(220, loc, 220, loc+37, HX8357_BLACK);
    tft_drawLine(221, loc, 221, loc+37, HX8357_BLACK);
    tft_drawLine(413, loc, 412, loc+37, HX8357_BLACK);
    tft_drawLine(412, loc, 413, loc+37, HX8357_BLACK);
}

void drawwholestaff()
{
    tft_fillScreen(HX8357_WHITE);
    drawstaff(30);
    drawstaff(105);
    drawstaff(180);
    drawstaff(255);
    
    drawbar(30);
    drawbar(105);
    drawbar(180); 
    drawbar(255);
    tft_setTextColor(HX8357_GREEN);
    tft_setTextSize(2);
    sprintf(buffer, "NEW\n");
    tft_setCursor(425, 40);
    tft_writeString(buffer);
    tft_setTextColor(HX8357_BLUE);
    sprintf(buffer, "REPLAY\n");
    tft_setCursor(410, 150);
    tft_writeString(buffer);
    tft_setTextColor(HX8357_RED);
    sprintf(buffer, "QUIT\n");
    
    tft_setCursor(420, 260);
    tft_writeString(buffer);
}

void drawnote(short x, short y, short base, short type)
{
    //HEAD
    if(type == WHOLE || type == HALF)
    {
        tft_drawRoundRect(x,   y,   12, 8, 4, HX8357_BLACK);
        tft_drawRoundRect(x+1, y+1, 10, 6, 3, HX8357_BLACK);
    }
    else if(type == QUARTER || type == EIGHTH)
    {
        tft_fillRoundRect(x, y, 12 ,8, 4, HX8357_BLACK);
    }
    
    //TAIL
    if(type == HALF || type == QUARTER || type == EIGHTH)
    {
        if(y <= base-22){
            tft_drawLine(x+2, y+4, x+2, y+32, HX8357_BLACK);
            tft_drawLine(x+1, y+4, x+1, y+32, HX8357_BLACK);
            if(type == EIGHTH)tft_drawBitmap(x-1, y+8, eighttail2, 13, 29,HX8357_BLACK) ; 
        }
        else{
            tft_drawLine(x+10, y+4, x+10, y-24, HX8357_BLACK);
            tft_drawLine(x+11, y+4, x+11, y-24, HX8357_BLACK);
            if(type == EIGHTH) tft_drawBitmap(x+8, y-30, eighttail1, 13, 28,HX8357_BLACK) ; 
        }
    }
    //LINES
    if(y == base )
    {
        tft_drawLine(x-3, y+3, x+14, y+3, HX8357_BLACK);
        tft_drawLine(x-3, y+4, x+14, y+4, HX8357_BLACK);
    }
    if(y == base-51 || y == base-55 )
    {
        tft_drawLine(x-3, base-48, x+14, base-48, HX8357_BLACK);
        tft_drawLine(x-3, base-47, x+14, base-47, HX8357_BLACK);
    }
    if(y == base-60 )
    {
        tft_drawLine(x-3, base-48, x+14, base-48, HX8357_BLACK);
        tft_drawLine(x-3, base-47, x+14, base-47, HX8357_BLACK);
        tft_drawLine(x-3, base-56, x+14, base-56, HX8357_BLACK);
        tft_drawLine(x-3, base-57, x+14, base-57, HX8357_BLACK);
    }
}

void smartnote(int dtemp,short nx,short cbase, short type)
{
    switch(dtemp){
        case 12:drawnote(nx,cbase   ,cbase,type);break;
        case 14:drawnote(nx,cbase-3 ,cbase,type);break;
        case 16:drawnote(nx,cbase-7 ,cbase,type);break;
        case 17:drawnote(nx,cbase-12,cbase,type);break;
        case 19:drawnote(nx,cbase-16,cbase,type);break;
        case 21:drawnote(nx,cbase-21,cbase,type);break;
        case 23:drawnote(nx,cbase-25,cbase,type);break;
        case 24:drawnote(nx,cbase-30,cbase,type);break;
        case 26:drawnote(nx,cbase-34,cbase,type);break;
        case 28:drawnote(nx,cbase-39,cbase,type);break;
        case 29:drawnote(nx,cbase-43,cbase,type);break;
        case 31:drawnote(nx,cbase-47,cbase,type);break;
        case 33:drawnote(nx,cbase-51,cbase,type);break;
        case 35:drawnote(nx,cbase-55,cbase,type);break;
        case 36:drawnote(nx,cbase-60,cbase,type);break;
        default:drawnote(nx,cbase,cbase,type );
    }
}

void adddot(int dtemp,short nx,short cbase)
{
    switch(dtemp){
        case 12:tft_fillCircle(nx+18,cbase+1 ,2,HX8357_BLACK);break;
        case 14:tft_fillCircle(nx+18,cbase+1 ,2,HX8357_BLACK);break;
        case 16:tft_fillCircle(nx+18,cbase-8 ,2,HX8357_BLACK);break;
        case 17:tft_fillCircle(nx+18,cbase-8 ,2,HX8357_BLACK);break;
        case 19:tft_fillCircle(nx+18,cbase-17,2,HX8357_BLACK);break;
        case 21:tft_fillCircle(nx+18,cbase-17,2,HX8357_BLACK);break;
        case 23:tft_fillCircle(nx+18,cbase-26,2,HX8357_BLACK);break;
        case 24:tft_fillCircle(nx+18,cbase-26,2,HX8357_BLACK);break;
        case 26:tft_fillCircle(nx+18,cbase-35,2,HX8357_BLACK);break;
        case 28:tft_fillCircle(nx+18,cbase-35,2,HX8357_BLACK);break;
        case 29:tft_fillCircle(nx+18,cbase-44,2,HX8357_BLACK);break;
        case 31:tft_fillCircle(nx+18,cbase-44,2,HX8357_BLACK);break;
        case 33:tft_fillCircle(nx+18,cbase-52,2,HX8357_BLACK);break;
        case 35:tft_fillCircle(nx+18,cbase-52,2,HX8357_BLACK);break;
        case 36:tft_fillCircle(nx+18,cbase-61,2,HX8357_BLACK);break;
        default:tft_fillCircle(nx+18,cbase,2,HX8357_BLACK );
    }
}

void drawrest(short x, short base, short type)
{
    if(type == WHOLE)  tft_fillRect(x, base - 30, 10,4,HX8357_BLACK);
    if(type == HALF)   tft_fillRect(x, base - 25, 10,4,HX8357_BLACK);
    if(type == QUARTER)tft_drawBitmap(x, base - 35, quarterrestbm, 8, 27,HX8357_BLACK) ;     
    if(type == EIGHTH) tft_drawBitmap(x, base - 27, eighthrestbm, 12, 16,HX8357_BLACK) ;
}

void smartjudge(int dis[50], int pit[50], int a, short cbase, int time)
{
    int first=0,d=0;
    first++;
    if(a == 0) drawrest(time-12,cbase, WHOLE);
    while(a != 0) 
    {   
        if(first)
        {
            first = 0;
            //if(dis[a]>=0 && dis[a]<12) smartnote(pit[a],dis[a]+35,cbase,WHOLE);
            if(dis[a]>=time-70 && dis[a]<time-47) {smartnote(pit[a],dis[a]+40,cbase,QUARTER); drawrest(time+8,cbase, HALF);}
            else if(dis[a]>=time-47 && dis[a]<time-24) smartnote(pit[a],dis[a]+40,cbase,HALF);
            else if(dis[a]>=time-24 && dis[a]<=time) smartnote(pit[a],dis[a]+40,cbase,QUARTER);
        }
        else
        {
            d = dis[a+1]-dis[a];
            if(d< 33 )        smartnote(pit[a],dis[a]+40,cbase,QUARTER);
            if(d>=33 && d<56 )smartnote(pit[a],dis[a]+40,cbase,HALF);
            if(d>=56 )        {smartnote(pit[a],dis[a]+40,cbase,HALF);adddot(pit[a],dis[a]+40,cbase);}//////////////////
        }
        //smartnote(pit[a],dis[a]+35,cbase,QUARTER);
        a--;
    }
    if(first == 0)
    {
        a++;
        //if(dis[a]>=0 && dis[a]<12) smartnote(pit[a],dis[a]+35,cbase,WHOLE);
        if(dis[a]>=time-70 && dis[a]<time-47) drawrest(time-37,cbase, QUARTER);
        else if(dis[a]>=time-47 && dis[a]<time-24) drawrest(time-26,cbase, HALF);
        else if(dis[a]>=time-24 && dis[a]<=time) {drawrest(time-26,cbase, HALF); drawrest(time+8,cbase, QUARTER);}
        a--;
    }
}

void smartjudge2(int dis[50], int pit[50], int m, short cbase, int time)
{
    int first=0,d=0,id[50]={0},i,a;
    first++;
    a = m;
    if(a == 0) drawrest(time-65 ,cbase, WHOLE);
    while(a != 0) 
    {   
        if(first)
        {
            first = 0;
            if     (dis[a]>=time-168 && dis[a]<time-144) {id[a] = 1; drawrest(time-120+40,cbase, QUARTER);drawrest(time-48+40,cbase, HALF);}
            else if(dis[a]>=time-144 && dis[a]<time-120) {smartnote(pit[a],dis[a]+40,cbase,QUARTER); drawrest(time-48+40,cbase, HALF);}
            else if(dis[a]>=time-120 && dis[a]<time-96 ) {id[a] = 1; drawrest(time-48+40,cbase, HALF);}
            else if(dis[a]>=time-96  && dis[a]<time-72 ) smartnote(pit[a],dis[a]+40,cbase,HALF);
            else if(dis[a]>=time-72  && dis[a]<time-48 ) {id[a] = 1; drawrest(time-24+40,cbase, QUARTER);}
            else if(dis[a]>=time-48  && dis[a]<time-24 ) smartnote(pit[a],dis[a]+40,cbase,QUARTER);
            else if(dis[a]>=time-24  && dis[a]<=time   ) id[a] = 1;   
        }
        else
        {
            d = dis[a+1]-dis[a];
            if     (d < 36 )          id[a] = 1;
            else if(d>=36  && d<60  ) smartnote(pit[a],dis[a]+40,cbase,QUARTER);
            else if(d>=60  && d<84  ) {smartnote(pit[a],dis[a]+40,cbase,QUARTER);adddot(pit[a],dis[a]+40,cbase);}
            else if(d>=84  && d<108 ) smartnote(pit[a],dis[a]+40,cbase,HALF);
            else if(d>=108 && d<132 ) {smartnote(pit[a],dis[a]+40,cbase,HALF);adddot(pit[a],dis[a]+40,cbase);}
            else if(d>=132 && d<156 ) {smartnote(pit[a],dis[a]+40,cbase,HALF);adddot(pit[a],dis[a]+40,cbase);}
            else if(d>=156          ) {smartnote(pit[a],dis[a]+40,cbase,HALF);adddot(pit[a],dis[a]+40,cbase);drawrest(time-36+40,cbase, EIGHTH);}
            
            
        }
        //smartnote(pit[a],dis[a]+35,cbase,QUARTER);
        a--;
    }
    
    for(i = 1;i<=m;i++)
    {
        if(id[i])
        {
            if(i+3<=m&&id[i+1]&&id[i+2]&&id[i+3]) {draw4eighth(dis[i]+40,pit[i],dis[i+1]+40,pit[i+1],dis[i+2]+40,pit[i+2],dis[i+3]+40,pit[i+3],cbase);i=i+3;}
            else if(i+2<=m&&id[i+1]&&id[i+2]){draw2eighth(dis[i]+40,pit[i],dis[i+1]+40,pit[i+1] ,cbase);smartnote(pit[i+2],dis[i+2]+40,cbase,EIGHTH);i=i+2;}
            else if(i+1<=m&&id[i+1]) {draw2eighth(dis[i]+40,pit[i],dis[i+1]+40,pit[i+1],cbase);i=i+1;}
            else smartnote(pit[i],dis[i]+40,cbase,EIGHTH);
        }
    }
    
    if(first == 0)
    {
        if     (dis[1]>=time-168 && dis[1]<time-144)  drawrest(time-142,cbase, EIGHTH);
        else if(dis[1]>=time-144 && dis[1]<time-120)  drawrest(time-126,cbase, QUARTER);
        else if(dis[1]>=time-120 && dis[1]<time-96)  {drawrest(time-126,cbase, QUARTER);drawrest(time-96,cbase, EIGHTH);}
        else if(dis[1]>=time-96  && dis[1]<time-72)  {drawrest(time-90, cbase, HALF);}
        else if(dis[1]>=time-72  && dis[1]<time-48)  {drawrest(time-90, cbase, HALF);drawrest(time-36,cbase, EIGHTH) ;}
        else if(dis[1]>=time-48  && dis[1]<time-24)  {drawrest(time-90, cbase, HALF);drawrest(time-30,cbase, QUARTER);}
        else if(dis[1]>=time-24  && dis[1]<=time)    {drawrest(time-90, cbase, HALF);drawrest(time-30,cbase, QUARTER); drawrest(time,cbase, EIGHTH);}     
    } 
}

void drawnotehead(int x, int y ,short base)
{
    tft_fillRoundRect(x, y, 12 ,8, 4, HX8357_BLACK);
    if(y == base )
    {
        tft_drawLine(x-3, y+3, x+14, y+3, HX8357_BLACK);
        tft_drawLine(x-3, y+4, x+14, y+4, HX8357_BLACK);
    }
    else if(y == base-51 || y == base-55 )
    {
        tft_drawLine(x-3, base-48, x+14, base-48, HX8357_BLACK);
        tft_drawLine(x-3, base-47, x+14, base-47, HX8357_BLACK);
    }
    else if(y == base-60 )
    {
        tft_drawLine(x-3, base-48, x+14, base-48, HX8357_BLACK);
        tft_drawLine(x-3, base-47, x+14, base-47, HX8357_BLACK);
        tft_drawLine(x-3, base-56, x+14, base-56, HX8357_BLACK);
        tft_drawLine(x-3, base-57, x+14, base-57, HX8357_BLACK);
    }
}

int dtemp2y(int dtemp, short cbase)
{
    switch(dtemp){
        case 12:return cbase;   break;
        case 14:return cbase-3; break;
        case 16:return cbase-7; break;
        case 17:return cbase-12;break;
        case 19:return cbase-16;break;
        case 21:return cbase-21;break;
        case 23:return cbase-25;break;
        case 24:return cbase-30;break;
        case 26:return cbase-34;break;
        case 28:return cbase-39;break;
        case 29:return cbase-43;break;
        case 31:return cbase-47;break;
        case 33:return cbase-51;break;
        case 35:return cbase-55;break;
        case 36:return cbase-60;break;
        default:return cbase;   break;
    }
}

void draw2eighth(int x0, int dtemp0, int x1, int dtemp1, short base)
{
    int y0,y1;
    y0 = dtemp2y(dtemp0,base);
    y1 = dtemp2y(dtemp1,base);
    drawnotehead(x0, y0 ,base);
    drawnotehead(x1, y1 ,base);
    
    if(y1>y0+6)
    {
        if(y0 <= base-22){
            tft_drawLine(x0+2, y0+4, x0+2, y1+32-5, HX8357_BLACK);
            tft_drawLine(x0+1, y0+4, x0+1, y1+32-5, HX8357_BLACK);        
            tft_drawLine(x1+2, y1+4, x1+2, y1+32, HX8357_BLACK);
            tft_drawLine(x1+1, y1+4, x1+1, y1+32, HX8357_BLACK);
            
            tft_drawLine(x0+1, y1+32-5, x1+2, y1+32, HX8357_BLACK);
            tft_drawLine(x0+1, y1+31-5, x1+2, y1+31, HX8357_BLACK);
            tft_drawLine(x0+1, y1+30-5, x1+2, y1+30, HX8357_BLACK);
            tft_drawLine(x0+1, y1+29-5, x1+2, y1+29, HX8357_BLACK);
        }
        else{
            tft_drawLine(x0+10, y0+4, x0+10, y0-24, HX8357_BLACK);
            tft_drawLine(x0+11, y0+4, x0+11, y0-24, HX8357_BLACK);
            tft_drawLine(x1+10, y1+4, x1+10, y0-24+5, HX8357_BLACK);
            tft_drawLine(x1+11, y1+4, x1+11, y0-24+5, HX8357_BLACK);
            
            tft_drawLine(x0+10, y0-24, x1+11, y0-24+5, HX8357_BLACK);
            tft_drawLine(x0+10, y0-23, x1+11, y0-23+5, HX8357_BLACK);
            tft_drawLine(x0+10, y0-22, x1+11, y0-22+5, HX8357_BLACK);
            tft_drawLine(x0+10, y0-21, x1+11, y0-21+5, HX8357_BLACK);
        }    
    }
    else if(y1<y0-6)
    {
        if(y0 <= base-22){
            tft_drawLine(x0+2, y0+4, x0+2, y0+32, HX8357_BLACK);
            tft_drawLine(x0+1, y0+4, x0+1, y0+32, HX8357_BLACK);        
            tft_drawLine(x1+2, y1+4, x1+2, y0+32-5, HX8357_BLACK);
            tft_drawLine(x1+1, y1+4, x1+1, y0+32-5, HX8357_BLACK);
            
            tft_drawLine(x0+1, y0+32, x1+2, y0+32-5, HX8357_BLACK);
            tft_drawLine(x0+1, y0+31, x1+2, y0+31-5, HX8357_BLACK);
            tft_drawLine(x0+1, y0+30, x1+2, y0+30-5, HX8357_BLACK);
            tft_drawLine(x0+1, y0+29, x1+2, y0+29-5, HX8357_BLACK);
        }
        else{
            tft_drawLine(x0+10, y0+4, x0+10, y1-24+5, HX8357_BLACK);
            tft_drawLine(x0+11, y0+4, x0+11, y1-24+5, HX8357_BLACK);
            tft_drawLine(x1+10, y1+4, x1+10, y1-24, HX8357_BLACK);
            tft_drawLine(x1+11, y1+4, x1+11, y1-24, HX8357_BLACK);
            
            tft_drawLine(x0+10, y1-24+5, x1+11, y1-24, HX8357_BLACK);
            tft_drawLine(x0+10, y1-23+5, x1+11, y1-23, HX8357_BLACK);
            tft_drawLine(x0+10, y1-22+5, x1+11, y1-22, HX8357_BLACK);
            tft_drawLine(x0+10, y1-21+5, x1+11, y1-21, HX8357_BLACK);
        }
    }
    else
    {
        if(y0 <= base-22){
            tft_drawLine(x0+2, y0+4, x0+2, y0+32, HX8357_BLACK);
            tft_drawLine(x0+1, y0+4, x0+1, y0+32, HX8357_BLACK);  
            tft_drawLine(x1+2, y1+4, x1+2, y1+32, HX8357_BLACK);
            tft_drawLine(x1+1, y1+4, x1+1, y1+32, HX8357_BLACK);
            
            tft_drawLine(x0+1, y0+32, x1+2, y1+32, HX8357_BLACK);
            tft_drawLine(x0+1, y0+33, x1+2, y1+33, HX8357_BLACK);
            tft_drawLine(x0+1, y0+34, x1+2, y1+34, HX8357_BLACK);
            tft_drawLine(x0+1, y0+35, x1+2, y1+35, HX8357_BLACK);
        }
        else{
            tft_drawLine(x0+10, y0+4, x0+10, y0-24, HX8357_BLACK);
            tft_drawLine(x0+11, y0+4, x0+11, y0-24, HX8357_BLACK);
            tft_drawLine(x1+10, y1+4, x1+10, y1-24, HX8357_BLACK);
            tft_drawLine(x1+11, y1+4, x1+11, y1-24, HX8357_BLACK);
            
            tft_drawLine(x0+10, y0-24, x1+11, y1-24, HX8357_BLACK);
            tft_drawLine(x0+10, y0-25, x1+11, y1-25, HX8357_BLACK);
            tft_drawLine(x0+10, y0-26, x1+11, y1-26, HX8357_BLACK);
            tft_drawLine(x0+10, y0-27, x1+11, y1-27, HX8357_BLACK);
        }
    }

}


int findmax(int x0,int x1,int x2, int x3)
{
    int max;
    if(x0>x1) max=x0;else max=x1;
    if(x2>max)max=x2;
    if(x3>max)max=x3;
    return max;
}

int findmin(int x0,int x1,int x2, int x3)
{
    int min;
    if(x0>x1) min=x1;else min=x0;
    if(min>x2)min=x2;
    if(min>x3)min=x3;
    return min;
}

void draw4eighth(int x0, int dtemp0, int x1, int dtemp1,int x2, int dtemp2, int x3, int dtemp3,  short base)
{
    int y,y0,y1,y2,y3;
    y0 = dtemp2y(dtemp0,base);
    y1 = dtemp2y(dtemp1,base);
    y2 = dtemp2y(dtemp2,base);
    y3 = dtemp2y(dtemp3,base);
    
    drawnotehead(x0, y0 ,base);
    drawnotehead(x1, y1 ,base);
    drawnotehead(x2, y2, base);
    drawnotehead(x3, y3 ,base);
    if(y0 <= base-22){
        y = findmax(y0,y1,y2,y3);

        tft_drawLine(x0+2, y0+4, x0+2, y+32, HX8357_BLACK);
        tft_drawLine(x0+1, y0+4, x0+1, y+32, HX8357_BLACK);        
        tft_drawLine(x1+2, y1+4, x1+2, y+32, HX8357_BLACK);
        tft_drawLine(x1+1, y1+4, x1+1, y+32, HX8357_BLACK);
        tft_drawLine(x2+2, y2+4, x2+2, y+32, HX8357_BLACK);
        tft_drawLine(x2+1, y2+4, x2+1, y+32, HX8357_BLACK);
        tft_drawLine(x3+2, y3+4, x3+2, y+32, HX8357_BLACK);
        tft_drawLine(x3+1, y3+4, x3+1, y+32, HX8357_BLACK);
            
        tft_drawLine(x0+1, y+32, x3+2, y+32, HX8357_BLACK);
        tft_drawLine(x0+1, y+31, x3+2, y+31, HX8357_BLACK);
        tft_drawLine(x0+1, y+30, x3+2, y+30, HX8357_BLACK);
        tft_drawLine(x0+1, y+29, x3+2, y+29, HX8357_BLACK);
    }
    else{
        y = findmin(y0,y1,y2,y3);
        
        tft_drawLine(x0+10, y0+4, x0+10, y-24, HX8357_BLACK);
        tft_drawLine(x0+11, y0+4, x0+11, y-24, HX8357_BLACK);
        tft_drawLine(x1+10, y1+4, x1+10, y-24, HX8357_BLACK);
        tft_drawLine(x1+11, y1+4, x1+11, y-24, HX8357_BLACK);
        tft_drawLine(x2+10, y2+4, x2+10, y-24, HX8357_BLACK);
        tft_drawLine(x2+11, y2+4, x2+11, y-24, HX8357_BLACK);
        tft_drawLine(x3+10, y3+4, x3+10, y-24, HX8357_BLACK);
        tft_drawLine(x3+11, y3+4, x3+11, y-24, HX8357_BLACK);
            
        tft_drawLine(x0+10, y-24, x3+11, y-24, HX8357_BLACK);
        tft_drawLine(x0+10, y-23, x3+11, y-23, HX8357_BLACK);
        tft_drawLine(x0+10, y-22, x3+11, y-22, HX8357_BLACK);
        tft_drawLine(x0+10, y-21, x3+11, y-21, HX8357_BLACK);
    }    
    
}